#pragma once

// MachPCBDrill, NC drill/routing program for Mach3
// Copyright (C) 201, Frank Tkalcevic, www.franksworkshop.com

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.



#define sEOL "\n"

class CGCode
{
    CString m_sGCode;

public:
    CGCode( bool bMetric )
    {
	if ( bMetric )
	    m_sGCode += "G17 G21 G40 G54 G64 G90";
	else
	    m_sGCode += "G17 G20 G40 G54 G64 G90";
	m_sGCode += sEOL;
    }

    ~CGCode(void)
    {
    }

    void SendComment( LPCSTR s )
    {
	// todo - Make sure there are no special characters.

	m_sGCode += "( ";
	m_sGCode += s;
	m_sGCode += " )";
	m_sGCode += sEOL;
    }

    void ToolChange( int nId, CString &sSize )
    {
	CString s;

	s.Format( "T%d M6 (%s)", nId, sSize );
	m_sGCode += s;
	m_sGCode += sEOL;
    }

    void ProgramStop()
    {
	m_sGCode += "M00\r\n";
    }

    void Append( const char *s, ... )
    {
	va_list argptr;
	va_start(argptr, s);

	CString sStr;
	sStr.FormatV( s, argptr );

	m_sGCode += sStr;
	m_sGCode += sEOL;
    }

    CString str()
    {
	return m_sGCode;
    }
};
