// MachPCBDrill, NC drill/routing program for Mach3
// Copyright (C) 201, Frank Tkalcevic, www.franksworkshop.com

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "stdafx.h"
#include "PCBDrillDlg.h"
#include "PCBDrill.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CPCBDrillApp

BEGIN_MESSAGE_MAP(CPCBDrillApp, CWinApp)
    ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()


// CPCBDrillApp construction

CPCBDrillApp::CPCBDrillApp()
{
    // TODO: add construction code here,
    // Place all significant initialization in InitInstance
}


// The one and only CPCBDrillApp object

CPCBDrillApp theApp;


// CPCBDrillApp initialization

BOOL CPCBDrillApp::InitInstance()
{
    ::CoInitializeEx( NULL, COINIT_APARTMENTTHREADED );

    INITCOMMONCONTROLSEX InitCtrls;
    InitCtrls.dwICC = ICC_WIN95_CLASSES;
    InitCommonControlsEx(&InitCtrls);

    CWinApp::InitInstance();
    m_hAccelTable = LoadAccelerators(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_ACCELERATOR1));

    AfxEnableControlContainer();

    // Standard initialization
    SetRegistryKey(_T("FranksWorkshop"));

    CPCBDrillDlg dlg;
    m_pDlg = &dlg;
    m_pMainWnd = m_pDlg;
    dlg.DoModal();
    m_pDlg = NULL;

    // Since the dialog has been closed, return FALSE so that we exit the
    //  application, rather than start the application's message pump.
    return FALSE;
}

void CPCBDrillApp::LogMessage( 	LPCSTR sFormat, ... )
{
    va_list args;
    va_start(args,sFormat);

    if ( m_pDlg )
	m_pDlg->LogMessage( sFormat, args );
}

BOOL CPCBDrillApp::ProcessMessageFilter(int code, LPMSG lpMsg)
{
    if (code < 0)
	CWinApp::ProcessMessageFilter(code, lpMsg);

    if ( m_pDlg && m_pDlg->m_hWnd && m_hAccelTable)
    {
	if (::TranslateAccelerator(m_pDlg->m_hWnd, m_hAccelTable, lpMsg))
	    return(TRUE);
    }

    return CWinApp::ProcessMessageFilter(code, lpMsg);
}

