// This file is based on the transformations in affine.c 
// from leptonlib-1.4.0 (http://www.leptonica.com/local-sources.html)

/*====================================================================*
-  Copyright (C) 2001 Leptonica.  All rights reserved.
-  This software is distributed in the hope that it will be
-  useful, but with NO WARRANTY OF ANY KIND.
-  No author or distributor accepts responsibility to anyone for the
-  consequences of using this software, or for whether it serves any
-  particular purpose or works at all, unless he or she says so in
-  writing.  Everyone is granted permission to copy, modify and
-  redistribute this source code, for commercial or non-commercial
-  purposes, with the following restrictions: (1) the origin of this
-  source code must not be misrepresented; (2) modified versions must
-  be plainly marked as such; and (3) this notice may not be removed
-  or altered from any source or modified source distribution.
*====================================================================*/

// MachPCBDrill, NC drill/routing program for Mach3
// Copyright (C) 201, Frank Tkalcevic, www.franksworkshop.com

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.



#include "StdAfx.h"
#include "Transformation.h"

CTransformation::CTransformation(void)
{
}

CTransformation::~CTransformation(void)
{
}
//Matrix AffineSequential(PointF[] dest, PointF[] src)
//{
//    if (dest.Length != 3)
//        throw new ApplicationException("Need 3 Destination points");
//    if (src.Length != 3)
//        throw new ApplicationException("Need 3 Source points");

//    double x1 = (double)src[0].X, y1 = (double)src[0].Y;
//    double x2 = (double)src[1].X, y2 = (double)src[1].Y;
//    double x3 = (double)src[2].X, y3 = (double)src[2].Y;

//    double x1p = (double)dest[0].X, y1p = (double)dest[0].Y;
//    double x2p = (double)dest[1].X, y2p = (double)dest[1].Y;
//    double x3p = (double)dest[2].X, y3p = (double)dest[2].Y;

//    double rad2deg = 180.0 / 3.1415926535;

//    if (y1 == y3)
//        throw new ApplicationException("y1 == y3");
//    if (y1p == y3p)
//        throw new ApplicationException("y1p == y3p");

//    /*-------------------------------------------------------------*
//    The horizontal shear is done to move the 3rd point to the
//    y axis.  This moves the 2nd point either towards or away
//    from the y axis, depending on whether it is above or below
//    the x axis.  That motion must be computed so that we know
//    the angle of vertical shear to use to get the 2nd point
//    on the x axis.  We must also know the x coordinate of the
//    2nd point in order to compute how much scaling is required
//    to match points on the axis.
//     *-------------------------------------------------------------*/

//    /* Shear angles required to put src points on x and y axes */
//    double th3 = Math.Atan2(x1 - x3, y1 - y3);
//    double x2s = (x2 - ((y1 - y2) * (x3 - x1)) / (y1 - y3));
//    if (x2s == x1)
//        throw new ApplicationException("x2s == x1");
//    double ph2 = Math.Atan2(y1 - y2, x2s - x1);

//    /* Shear angles required to put dest points on x and y axes.
//     * Use the negative of these values to instead move the
//     * src points from the axes to the actual dest position.
//     * These values are also needed to scale the image. */
//    double th3p = Math.Atan2(x1p - x3p, y1p - y3p);
//    double x2sp = (x2p - ((y1p - y2p) * (x3p - x1p)) / (y1p - y3p));
//    if (x2sp == x1p)
//        throw new ApplicationException("x2sp == x1p!");
//    double ph2p = Math.Atan2(y1p - y2p, x2sp - x1p);


//    Matrix m = new Matrix();
//    m.Shear((float)th3, (float)ph2);

//    /* Shear image to first put src point 3 on the y axis,
//     * and then to put src point 2 on the x axis */
//    pixHShearIP(pixt1, y1, th3, L_BRING_IN_WHITE);
//    pixVShearIP(pixt1, x1, ph2, L_BRING_IN_WHITE);




//    /* Scale image to match dest scale.  The dest scale
//     * is calculated above from the angles th3p and ph2p
//     * that would be required to move the dest points to
//     * the x and y axes. */
//    double scalex = (x2sp - x1p) / (x2s - x1);
//    double scaley = (y3p - y1p) / (y3 - y1);





//    /*-------------------------------------------------------------*
//    Scaling moves the 1st src point, which is the origin. 
//    It must now be moved again to coincide with the origin
//    (1st point) of the dest.  After this is done, the 2nd
//    and 3rd points must be sheared back to the original
//    positions of the 2nd and 3rd dest points.  We use the
//    negative of the angles that were previously computed
//    for shearing those points in the dest image to x and y
//    axes, and take the shears in reverse order as well.
//     *-------------------------------------------------------------*/
//    /* Shift image to match dest origin. */
//    double x1sc = (scalex * x1);   /* x comp of origin after scaling */
//    double y1sc = (scaley * y1);   /* y comp of origin after scaling */






//    /* Shear image to take points 2 and 3 off the axis and
//     * put them in the original dest position */
//    pixVShearIP(pixt2, x1p, -ph2p, L_BRING_IN_WHITE);
//    pixHShearIP(pixt2, y1p, -th3p, L_BRING_IN_WHITE);

//}



/*-------------------------------------------------------------*
*               Gauss-jordan linear equation solver           *
*-------------------------------------------------------------*/
/*!
*  gaussjordan()
*
*      Input:   a  (n x n matrix)
*               b  (rhs column vector)
*               n  (dimension)
*      Return:  0 if ok, 1 on error
*
*      Note side effects:
*            (1) the matrix a is transformed to its inverse
*            (2) the vector b is transformed to the solution X to the
*                linear equation AX = B
*
*      Adapted from "Numerical Recipes in C, Second Edition", 1992
*      pp. 36-41 (gauss-jordan elimination)
*/
int CTransformation::gaussjordan(double a[T_SIZE][T_SIZE], double b[T_SIZE])
{
    int i, icol=0, irow=0, j, k, l, ll;
    int indexc[T_SIZE], indexr[T_SIZE], ipiv[T_SIZE];
    double pivinv;
    double big;

    memset( indexc, 0, sizeof(indexc));
    memset( indexr, 0, sizeof(indexr));
    memset( ipiv, 0, sizeof(ipiv));

    for (i = 0; i < T_SIZE; i++)
    {
	big = 0.0;
	for (j = 0; j < T_SIZE; j++)
	{
	    if (ipiv[j] != 1)
	    {
		for (k = 0; k < T_SIZE; k++)
		{
		    if (ipiv[k] == 0)
		    {
			if (abs(a[j][k]) >= big)
			{
			    big = abs(a[j][k]);
			    irow = j;
			    icol = k;
			}
		    }
		    else if (ipiv[k] > 1)
		    {
			throw "singular matrix";
		    }
		}
	    }
	}

	++(ipiv[icol]);

	if (irow != icol)
	{
	    double temp;
	    for (l = 0; l < T_SIZE; l++)
	    {
		temp = a[irow][l];
		a[irow][l] = a[icol][l];
		a[icol][l] = temp;
	    }
	    temp = b[irow];
	    b[irow] = b[icol];
	    b[icol] = temp;
	}

	indexr[i] = irow;
	indexc[i] = icol;
	if (a[icol][icol] == 0.0)
	    throw "singular matrix";
	pivinv = 1.0 / a[icol][icol];
	a[icol][icol] = 1.0;
	for (l = 0; l < T_SIZE; l++)
	    a[icol][l] *= pivinv;
	b[icol] *= pivinv;

	for (ll = 0; ll < T_SIZE; ll++)
	    if (ll != icol)
	    {
		double dum = a[ll][icol];
		a[ll][icol] = 0.0;
		for (l = 0; l < T_SIZE; l++)
		    a[ll][l] -= a[icol][l] * dum;
		b[ll] -= b[icol] * dum;
	    }
    }

    for (l = T_SIZE - 1; l >= 0; l--)
    {
	if (indexr[l] != indexc[l])
	    for (k = 0; k < T_SIZE; k++)
	    {
		double temp = a[k][indexr[l]];
		a[k][indexr[l]] = a[k][indexc[l]];
		a[k][indexc[l]] = temp;
	    }
    }

    return 0;
}


CMatrix CTransformation::affineXformCoeffs(CPointF dest[], CPointF src[])
{
    double x1 = (double)src[0].X, y1 = (double)src[0].Y;
    double x2 = (double)src[1].X, y2 = (double)src[1].Y;
    double x3 = (double)src[2].X, y3 = (double)src[2].Y;

    double b[T_SIZE];
    b[0] = (double)dest[0].X; b[1] = (double)dest[0].Y;
    b[2] = (double)dest[1].X; b[3] = (double)dest[1].Y;
    b[4] = (double)dest[2].X; b[5] = (double)dest[2].Y;

    double a[T_SIZE][T_SIZE];
    memset( a, 0, sizeof(a) );
    a[0][0] = x1;
    a[0][1] = y1;
    a[0][2] = 1.0;
    a[1][3] = x1;
    a[1][4] = y1;
    a[1][5] = 1.0;
    a[2][0] = x2;
    a[2][1] = y2;
    a[2][2] = 1.0;
    a[3][3] = x2;
    a[3][4] = y2;
    a[3][5] = 1.0;
    a[4][0] = x3;
    a[4][1] = y3;
    a[4][2] = 1.0;
    a[5][3] = x3;
    a[5][4] = y3;
    a[5][5] = 1.0;

    gaussjordan(a, b);

    //x' = c[0]x + c[1]y + c[2]
    //y' = c[3]x + c[4]y + c[5]
    //double x = b[0] * x1 + b[1] * y1 + b[2];
    //double y = b[3] * x1 + b[4] * y1 + b[5];

    CMatrix m(b[0], b[3], b[1], b[4], b[2], b[5]);
    //PointF[] p = new PointF[] { new PointF((float)x1, (float)y1) };
    //m.TransformPoints(p);

    return m;
}



